package com.cmb.util;

import com.fasterxml.jackson.databind.ObjectMapper;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Value;

import java.util.HashMap;
import java.util.Map;

//构造请求报文工具类
public class GenerateUtil {

    private static final Logger LOGGER = Logger.getLogger(GenerateUtil.class);

    @Value("${cmb.version}")
    private static String version;
    @Value("${cmb.encoding}")
    private static String encoding;
    @Value("${cmb.signMethod}")
    private static String signMethod;
    public static final String privateKey = "D5F2AFA24E6BA9071B54A8C9AD735F9A1DE9C4657FA386C09B592694BC118B38";
    public static final String publicKey = "MFkwEwYHKoZIzj0CAQYIKoEcz1UBgi0DQgAE6Q+fktsnY9OFP+LpSR5Udbxf5zHCFO0PmOKlFNTxDIGl8jsPbbB/9ET23NV+acSz4FEkzD74sW2iiNVHRLiKHg==";


    public static String initRequestParam(Pojo pojo){

        //设置公共请求参数
        Map<String,String> resultPublicParam = new HashMap<>();
        resultPublicParam.put("version",version);
        resultPublicParam.put("encoding",encoding);
        resultPublicParam.put("sign_method", signMethod);

        //初始化业务请求参数

        try {
            ObjectMapper objectMapper = new ObjectMapper();
            String bizContent = objectMapper.writeValueAsString(pojo);
            System.out.println(bizContent);
            resultPublicParam.put("biz_content",bizContent);

            //对待加签内容进行排序拼接
            String signStr = SignatureUtil.getSignContent(resultPublicParam);
            //加签
            String sign = SM2Util.sm2Sign(signStr, privateKey);

            resultPublicParam.put("sign",sign);

            String requestStr  = objectMapper.writeValueAsString(resultPublicParam);
            LOGGER.info("加签后的报文内容：" + requestStr);
            return requestStr;
        }catch (Exception ex){
            ex.printStackTrace();
            return null;
        }
    }

    /**
     * 处理响应报文
     * @param responseMap
     * @return
     */
    public static void handleResponse(Map<String,String> responseMap){

        if( null == responseMap){
            LOGGER.equals("响应的内容为空");
            return ;
        }
        try {
            ObjectMapper objectMapper = new ObjectMapper();
            LOGGER.info("收到响应的内容为：" + objectMapper.writeValueAsString(responseMap));
            //验签
            String sign = responseMap.remove("sign");
            //生成验签字符串
            String signStr = SignatureUtil.getSignContent(responseMap);
            boolean flag = SM2Util.sm2Check(signStr,sign, publicKey);
            if( flag ){
                LOGGER.info("验签成功！");
            } else {
                LOGGER.error("验签失败！");
            }
            return;

        }catch (Exception ex){
            LOGGER.equals("系统异常");
            return;
        }
    }


}
